
function music_downloader()
	liberar(24)
	link={}
	
	if keyboard==1 then 
		busqueda_inicial=teclado(1,"Canción a buscar",25,"")
	else 
		busqueda_inicial=os.osk("Cancion a buscar","",25,1,2)
	end
	
	if busqueda_inicial=="" then WiFi() end
	busqueda_inicial=busqueda_inicial:gsub(" ","-")
	busqueda=busqueda_inicial
	md_search()
	txt=nil
	archivo:close()
	more=2

	if #link>0 then
		actual=1
		while true do
			controls.read()
			fondodown:blend(0,0,150)
			if controls.press("down") then actual=actual+1 elseif controls.press("up") then actual=actual-1 end
			if actual>#link then actual=1 elseif actual<1 then actual=#link end
			if #link<=10 then
				for i=1,#link do
					if actual==i then
						screen.print(240,20*i,link[i][2],0.7,verde,0,"center")
					else
						screen.print(240,20*i,link[i][2],0.6,rojo,0,"center")
					end
				end
			else
				if #link-actual>10 then
					for i=actual,actual+10 do
						if actual==i then
							screen.print(240,20*i+20-actual*20,link[i][2],0.7,verde,0,"center")
						else
							screen.print(240,20*i+20-actual*20,link[i][2],0.6,rojo,0,"center")
						end
					end
				else
					for i=#link-10,#link do
						if actual==i then
							screen.print(240,20*i+20-(#link-10)*20,link[i][2],0.7,verde,0,"center")
						else
							screen.print(240,20*i+20-(#link-10)*20,link[i][2],0.6,rojo,0,"center")
						end
					end
				end
			end
			if controls.press("triangle") then
				busqueda=busqueda_inicial.."/"..more
				more=more+1
				md_search()
			end
			if controls.press("cross") then md_down(link[actual]) end
			if controls.press("circle") then WiFi() end
			screen.print(240,255,"Elemento "..actual.." de "..#link,0.7,azul,0,"center")
			screen.flip()
		end
	else
		if os.message("No se ha encontrado ningún resultado. ¿Deseas volver a intentarlo?",1)==1 then
			music_downloader()
		else
			WiFi()
		end
	end
end

--Buscamos las canciones
function md_search()

	http.get("http://www.goear.com/search/"..busqueda,"temporal")

	archivo=io.open("temporal","r+")
	txt=archivo:read("*a")
	while txt:find('href="listen/')!=nil do
		a,b=txt:find('href="listen/')
		txt=txt:sub(b+1,#txt)
		a=txt:find('">')
		link[#link+1]={txt:sub(1,7),txt:sub(9,a-1)}
		txt=txt:sub(a+2,#txt)
	end
	for i=1,#link do
		link[i][2]=link[i][2]:gsub("-"," ")
	end
	files.remove("temporal")
	txt=nil
end

--Descargar canción
function md_down(tabla)
http.get("http://www.goear.com/tracker758.php?f="..tabla[1],"down")

archivo=io.open("down","r+")
txt=archivo:read("*a")
if txt:find('path="')!=nil then
	a,b=txt:find('path="')
	txt=txt:sub(b+1,#txt)
	a=txt:find('"')
	http.get(txt:sub(1,a-1),"ms0:/MUSIC/"..tabla[2]..".mp3")
	if files.exists("ms0:/MUSIC/"..tabla[2]..".mp3") then
		os.message("Descargado con éxito en la ruta ms0:/MUSIC")
	else
		os.message("Descarga cancelada")
	end
else
	os.message("Imposible descargar")
end

files.remove("down")
txt=nil

actual=1
end


